unit td;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  StdCtrls, Forms, DBCtrls, DB, DBTables, Mask, ExtCtrls, ComCtrls, Grids,
  DBGrids, Dialogs;

type
  TToDoForm = class(TForm)
    Table1ItemNumber: TAutoIncField;
    Table1Item: TStringField;
    Table1Priority: TSmallintField;
    Table1Type: TStringField;
    Table1Dateentered: TDateField;
    Table1Datedue: TDateField;
    Table1Done: TBooleanField;
    Table1Notes: TBlobField;
    ScrollBox: TScrollBox;
    Label1: TLabel;
    EditItemNumber: TDBEdit;
    Label2: TLabel;
    EditItem: TDBEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    CheckBoxDone: TDBCheckBox;
    Label8: TLabel;
    DBNavigator: TDBNavigator;
    Panel1: TPanel;
    DataSource1: TDataSource;
    Panel2: TPanel;
    Table1: TTable;
    DBRichEdit1: TDBRichEdit;
    DTPDateEntered: TDateTimePicker;
    DBRadioGroup1: TDBRadioGroup;
    DBComboBox1: TDBComboBox;
    DBGrid1: TDBGrid;
    DTPDatedue: TDateTimePicker;
    GroupBox1: TGroupBox;
    ItemBtn: TButton;
    DoneBtn: TButton;
    PriorityBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure DTPDateEnteredChange(Sender: TObject);
    procedure DBRichEdit1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ItemBtnClick(Sender: TObject);
    procedure DoneBtnClick(Sender: TObject);
    procedure EditDateenteredExit(Sender: TObject);
    procedure DTPDatedueChange(Sender: TObject);
    procedure Table1AfterScroll(DataSet: TDataSet);
    procedure Table1AfterInsert(DataSet: TDataSet);
    procedure PriorityBtnClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  ToDoForm: TToDoForm;

implementation

{$R *.DFM}

procedure TToDoForm.FormCreate(Sender: TObject);
begin
  Table1.Open;
end;

procedure TToDoForm.DTPDateEnteredChange(Sender: TObject);
begin
    DataSource1.Edit;   // put into edit mode and assign the date
    Table1Dateentered.Value := DTPDateEntered.Date;
end;

procedure TToDoForm.DBRichEdit1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if (ssCtrl in Shift) and (Chr(Key) = 'B') then
   with DBRichEdit1.SelAttributes do
   begin
      if fsBold in Style then
         Style := Style - [fsBold]
      else Style := Style+[fsBold];
   end
   else
   if (ssCtrl in Shift) and (Chr(Key) = 'U') then
   with DBRichEdit1.SelAttributes do
   begin
      if fsUnderline in Style then
         Style := Style - [fsUnderline]
      else Style := Style+[fsUnderline];
   end
end;

procedure TToDoForm.ItemBtnClick(Sender: TObject);
begin
   if Table1.IndexName = 'ItemIDX' then
      Table1.IndexName := ''
   else Table1.IndexName := 'ItemIDX';
end;

procedure TToDoForm.DoneBtnClick(Sender: TObject);
begin
   if Table1.IndexName = 'DoneIDX' then
      Table1.IndexName := ''
   else Table1.IndexName := 'DoneIDX';
end;

procedure TToDoForm.PriorityBtnClick(Sender: TObject);
begin
   if Table1.IndexName = 'PriorityIDX' then
      Table1.IndexName := ''
   else Table1.IndexName := 'PriorityIDX';
end;

procedure TToDoForm.EditDateenteredExit(Sender: TObject);
begin
   DTPDateEntered.Date := Table1Dateentered.Value;
end;

procedure TToDoForm.DTPDatedueChange(Sender: TObject);
begin
    DataSource1.Edit;   // put into edit mode and assign the date
    Table1Datedue.Value := DTPDatedue.Date;
end;

procedure TToDoForm.Table1AfterScroll(DataSet: TDataSet);
begin
   DTPDateEntered.Date := Table1Dateentered.Value;
   DTPDateDue.Date := Table1Datedue.Value;
end;

procedure TToDoForm.Table1AfterInsert(DataSet: TDataSet);
begin
   Table1Dateentered.Value := Now;
   Table1Datedue.Value := Now;
   Table1Priority.Value := 2;
end;


end.
